#include<cstdio>
#include<vector>
#include<queue>

using namespace std;

const int NMAX=1000000;
const int MMAX=10000000;
class Edge
{
public:
  int next,len,curr;
  Edge(int a,int c, int b)
  {
    this->curr=a;
    this->len=b;
    this->next=c;
  }
  bool operator ()( const Edge& hs)
  {
    return this->len > hs.len;
  }

  
};

bool operator>( const Edge& lhs, const Edge& rhs )
{
    return lhs.len> rhs.len;
}


vector<Edge>graph[NMAX];

int n,s,e,m=0;

void Init()
{
  scanf("%d%d%d",&n,&s,&e);
  for(int i=0;i<n;i++)
  {
    int u,v,w;
    scanf("%d%d%d",&u,&v,&w);
    if(v>m) m=v;
    Edge a(u,v,w);
    graph[u].push_back(a);
    for(int i=u+1;i<v;i++)
    {
      Edge c(i,v,w);
      graph[i].push_back(c);
    }
    for(int i=u;v>u;v--)
    {
      Edge c(i,v,w);
      graph[i].push_back(c);
    }
    //Edge b(u,u+1,1);
    //graph[u].push_back(b);
  }
  
  for(int i=1;i<=e;i++)
  { 
    Edge b(i,i+1,1);
    graph[i].push_back(b);

  }

}

int used[NMAX];
int dist[NMAX];

void Solve()
{
    for(int i=1;i<m;i++)
    {
      dist[i]=MMAX;
    }
    dist[s]=0;
    used[s]=1;
    priority_queue< Edge, vector<Edge>, greater<Edge> > q;
    for(int i=0;i<graph[s].size();i++)
    {
      dist[graph[s][i].next]=graph[s][i].len;
      q.push(graph[s][i]);
    }
  while(!q.empty())
  {
    Edge a=q.top();
    //printf("%d %d %d\n",a.curr,a.next,a.len);
    //q.pop();;
    q.pop();
    int n=a.next;
    for(int i=0;i<graph[n].size();i++)
    {
      if(used[graph[n][i].next]!=1)
      {
      int alt=graph[n][i].len+dist[n];
      if(dist[graph[n][i].next]>alt)
	{
	  dist[graph[n][i].next]=alt;
	  
	}
      q.push(graph[n][i]);
	
      }
    }
    used[n]=1;
    
  }

}
int main()
{
  Init();
  Solve();
  /*for(int i=7;i<40;i++)
  {
    printf("%d ",dist[i]);
  }*/
  printf("%d\n",dist[e]);
  return 0;
}