#include <iostream>
#include <vector>

using namespace std;

struct point
{
       int x,y;
       point(){}
       point(int _x, int _y)
       {
                 x=_x;
                 y=_y;
       }
};

struct rect
{
       int x1, y1, x2, y2;
       rect(){}
       rect(int _x1, int _y1, int _x2, int _y2)
       {
                x1=_x1;
                y1=_y1;
                x2=_x2;
                y2=_y2;
       }
};

rect makerect(point A, point B)
{
     if(A.x>B.x) swap(A,B);
     else if(A.x==B.x) if(A.y>B.y) swap(A,B);
     
     if(A.y>B.y) swap(A.y, B.y);
     
     return rect(A.x,A.y,B.x,B.y);
}

struct segment
{
       int a,b;
       segment(){}
       segment(int _a, int _b)
       {
                   a=_a;
                   b=_b;
       }
};

struct pseg
{
       int x, type;
       pseg(){}
       pseg(int _x, int _type)
       {
                x=_x;
                type=_type;
       }
       bool operator<(const pseg a)
       const{
            if(x<a.x) return true;
            else if(x==a.x) return type<a.type;
            return false;
       }
            
};

vector<segment> v[40000];

long long solve(vector<segment> s)
{
     if(s.empty()) return 0;
     long long res=0;
     
     /*cout << "sol " << ":\n";
     for(int i=0; i<s.size(); i++)
     cout << s[i].a << ' ' << s[i].b << endl;*/
     
     vector<pseg> q;
     for(int i=0; i<s.size(); i++)
     {
             q.push_back(pseg(s[i].a, 1));
             q.push_back(pseg(s[i].b, 2));
     }
     
     
     int m=q.size();
     sort(q.begin(), q.end());
     
     int bro=1, brz=0;
     int last=q[0].x;
     
     /*cout << "sol " << ":\n";
     for(int i=0; i<m; i++) cout << q[i].x << ' ' << q[i].type << endl;*/
     
     for(int i=1; i<m; i++)
     {
             //cout << "OK" << endl;
             if(q[i].type==1) bro++;
             else bro--;
             if(bro==0) res+=(q[i].x-last);
             if(bro==1 && q[i].type==1) last=q[i].x;
     }
     
     return res;
}
     


int main()
{
    int n;
    cin >> n;
    int a,b,c,d;
    
    for(int i=0; i<n; i++)
    {
            cin >> a >> b >> c >> d;
            point A=point(a,b), B=point(c,d);
            rect R=makerect(A,B);
            
            //cout << R.x1 << ' ' << R.y1 << ' ' << R.x2 << ' '   << R.y2 << endl;
            
            for(int i=R.x1+1; i<=R.x2; i++)
            {
                    v[i+10000].push_back(segment(R.y1, R.y2));
            }
    }
    
    
    long long res=0;
    for(int i=0; i<=30000; i++)
    {
            res+=solve(v[i]);
    }
    
    cout << res;
    return 0;
}
