#include <iostream>
#define MAXN 23
using namespace std;

bool DEBUG = false;
int n;
unsigned long long z[MAXN];
unsigned long long t[MAXN];
unsigned long long x;

void makeRoundedAvgZ() {
    if(DEBUG)
        cout<<"Starting Rounded AVG Z: \n";
    unsigned long long l=0;
    unsigned long long m=1;
    unsigned long long k=0;
    unsigned long long temp;
    int i,j;
    for(i=0;i<n;i++) {
        temp=1;
        m*=t[i];
        for(j=0;j<n;j++) {
            if(j!=i)
                temp*=t[j];
        }
        l+=temp;
    }
    if(DEBUG)
        cout<<"Founded l,m : "<<l<<" "<<m<<endl;
    unsigned long long xW = (x/l)*m;
    unsigned long long lW = ((x%l)*m)/l;
    unsigned long long avgZ = xW+lW;

    if(DEBUG){
        cout<<"xW lW : "<<xW<<" "<<lW<<endl;
        cout<<"Rounded avg is : "<<avgZ<<endl;
    }

    for(i=0;i<n;i++) {
        z[i] = (avgZ/t[i]);
        if(DEBUG)
            cout<<"Avg "<<i<<" is "<<z[i]<<endl;
    }
}

void fullFill() {
    unsigned long long q = 0;
    unsigned long long temp = 0;
    int i,tindex;
    for(i=0;i<n;i++)
        temp+=z[i];
    unsigned long long left = x-temp;
    if(DEBUG)
        cout<<"There are "<<left<<" left pancackes\n";
    while(left!=0) {
        q=t[0]*(z[0]+1);
        tindex=0;
        for(i=1;i<n;i++) {
            temp=t[i]*(z[i]+1);
            if(q>temp) {
                q=temp;
                tindex=i;
            }
        }
        z[tindex]++;
        left--;
    }
}

unsigned long long minTime() {
    unsigned long long q = z[0]*t[0];
    int i;
    unsigned long long temp;
    for(i=1;i<n;i++){
        temp=z[i]*t[i];
        if(temp>q)
            q=temp;
    }
    return q;
}


int main() {
    cin>>x>>n;
    for(int i=0;i<n;i++) {
        cin>>t[i];
        z[i]=0;
    }
    if(DEBUG)
        cout<<"Make Random Avg Z\n";
    makeRoundedAvgZ();
    if(DEBUG)
        cout<<"Full fill\n";
    fullFill();
    if(DEBUG)
        cout<<"Output Min Time\n";
    cout<<minTime()<<endl;
    return 0;
}
