#include <cstdio>
#include <cmath>
#define MAXB 1000000

struct Point
{
    int x, y;
};



class Box
{
    public:
    Point A, B;

    int area;

    Box() {  }

    void Read()
    {
        int ax, ay, bx, by;
        scanf("%d %d %d %d", &ax, &ay, &bx, &by);
        A.x = (ax < bx) ? (ax) : (bx);
        A.y = (ay < by) ? (ay) : (by);

        B.x = (ax > bx) ? (ax) : (bx);
        B.y = (ay > by) ? (ay) : (by);

        this->area = (B.x - A.x)*(B.y - A.y);

       // printf("A: %d %d %d %d\n", A.x, A.y, B.x, B.y);
    }

    bool Exist()
    {
        return ((B.x - A.x) > 0) && ((B.y - A.y) > 0);
    }

    bool Contain(int x, int y)
    {
        //printf("%d %d %d %d %d %d\n", x, y, A.x, A.y, B.x, B.y);
        return A.x < x && x < B.x && A.y < y && y < B.y;
    }
};

Box boxes[MAXB];
int index;  // = 0

int GetMidDif(int* arr)
{
    int t;
    for(int j, i = 0; i < 4; i++)
        for(j = 0; j < 3; j++)
        {
            if(arr[j] > arr[j+1])
            {
                t = arr[j];
                arr[j] = arr[j+1];
                arr[j+1] = t;
            }
        }

    //printf("%d %d\n", arr[2], arr[1]);
    return arr[2] - arr[1];
}

int GetCollision(Box *b, Box* c)
{
    /*
    if(b->Contain(c->A.x, c->A.y) ||
       b->Contain(c->B.x, c->B.y) ||
       b->Contain(c->A.x, c->B.y) ||
       b->Contain(c->B.x, c->A.y) || //------
       c->Contain(b->A.x, b->A.y) ||
       c->Contain(b->B.x, b->B.y) ||
       c->Contain(b->A.x, b->B.y) ||
       c->Contain(b->B.x, b->A.y) ||
       (((c->B.y > b->B.y && b->B.y > c->A.y) || (c->B.y > b->A.y && b->A.y > c->A.y) ) &&
             ((c->B.x > b->B.x && b->B.x > c->A.x) || (c->B.x > b->A.x && b->A.x > c->A.x)) ) ||
       (((b->B.y > c->B.y && c->B.y > b->A.y) || (b->B.y > c->A.y && c->A.y > b->A.y) ) &&
             ((b->B.x > c->B.x && c->B.x > b->A.x) || (b->B.x > c->A.x && c->A.x > b->A.x)) ))
             */
    if(!((c->B.x < b->A.x ) || (b->B.x < c->A.x ) || (c->B.y < b->A.y ) || (b->B.y < c->A.y )))
    {

       int arr1[] = {b->A.x, b->B.x, c->A.x, c->B.x};
        int arr2[] = {b->A.y, b->B.y, c->A.y, c->B.y};
        //printf("area: %d\n",  GetMidDif(arr1)*GetMidDif(arr2));
        return GetMidDif(arr1)*GetMidDif(arr2);
    }
    else return 0;
}

void AddBox()
{
    Box b;
    b.Read();
    if(b.Exist())
    {
        for(int i = 0; i < index; i++)
        {
            b.area -= GetCollision(&b, &boxes[i]);
            //printf("area")
        }
        boxes[index++] = b;
    }
}

int totArea;

int main()
{
    int N;
    scanf("%d", &N);
    for(int i = 0; i < N; i++)
    {
        AddBox();
    }

    for(int i = 0; i < index; i++)
    {
        totArea += boxes[i].area;
    }

    printf("%d\n", totArea);
    return 0;
}
