/*
TASK: pancakes
LANG: C++
KEYW: Binary search
*/
#include <iostream>
#include <vector>
#include <cstdio>
#include <ctime>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <cstring>
#include <string>
#include <queue>
#include <set>

typedef long long ll;

const ll LLINF = 1LL << 60;
const int INF = 1 << 30;
const double EPS = 1e-9;

using namespace std;

const int MAXN = 1 << 5;

ll N, P;
int t[MAXN];

bool can( ll x ){
    ll pc = 0;
    ///double pcll = 0;
    
    /// max{pc} = max{N} *( max{x} / min{t[i]} ) = 20 * 10^15 / 1 = 2x10^1 * 10^15 = 2x10^16
    
    for( int i = 0 ; i < N ; i++ )
        pc += x / t[i]; ///pcll += (double) x / t[i];;
    /*
    if( pcll / 1e3 >= P )
        return true;
    */
    return pc >= P;
}

void read(){
	/*
	scanf("%d %d", &P, &N);
	for( int i = 0 ; i < N ; i++ )
        scanf("%d", &t[i]);
    */
    cin >> P >> N;
    for( int i = 0 ; i < N ; i++ )
        cin >> t[i];
}

/// Time (in the worst case) -> X * max{ t[i] } = 10^15 * 5x10^2 = 5x10^17

void solve(){
    ll l = 0, r = LLINF, last = -1;
    
    while( l <= r ){
        ll m = ( l + r ) >> 1;
        
        if( can(m) )
            last = m, r = m - 1;
        else
            l = m + 1;
    }
    
    cout << last << endl;
}

int main(){
	//freopen( "pancakes.in" , "r" , stdin );
	//freopen( "pancakes.out" , "w" , stdout );
	
	read();
	//init();
	solve();
	
	return 0;
}
