#include <iostream>

#define MAXN 100
#define MAXITS 5000

using namespace std;

struct rect { int x1,y1,x2,y2; } r[MAXN],its[MAXITS], temp[MAXITS]; //its - intersections

int max(int x,int y) { if(x>=y) return x; return y; }
int min(int x,int y) { if(x<=y) return x; return y; }

bool same(rect r1,rect r2) { return (r1.x1==r2.x1 && (r1.y1==r2.y1) && (r1.x2==r2.x2) && (r1.y2==r2.y2)); }
int rectArea(rect a) { return (a.x2-a.x1)*(a.y2-a.y1); }

rect intersect(rect r1,rect r2) {
	rect a;
	a.x1 = max(r1.x1,r2.x1);
	a.y1 = max(r1.y1,r2.y1);
	a.x2 = min(r1.x2,r2.x2);
	a.y2 = min(r1.y2,r2.y2);

	//the rectangle might not be valid (x1>x2 || y1>y2), so we make its area 0
	a.x1 = min(a.x1,a.x2);
	a.y1 = min(a.y1,a.y2);
	return a;
}


int itsArea(int n) {
	if(n==1) return rectArea(its[0]);

	int c=0,a=0; //area
	for(int i=0;i<n;i++) {
		a += rectArea(its[i]);
		for(int j=i+1;j<n;j++) {
			temp[c]=intersect(its[i],its[j]);
			c++;
		}
	}
	if(a==0)
		return 0;

	for(int i=0;i<c;i++) its[i]=temp[c];
	a -= itsArea(c); //c = n-1
	return a;
}

int main() {
	int n,area;
	bool f;

	cin >> n;

	for(int i=0;i<n;i++) {
		cin >> r[i].x1 >> r[i].y1 >> r[i].x2 >> r[i].y2;

		if(i>0) {
			f = (rectArea(r[i])==0);

			for(int j=i-1;j>=0 && (!f);j--) {
				f = same(r[i],r[j]);
				its[j]=intersect(r[i],r[j]);
			}

			if(f) {
					i--;
					n--;
				}
			else area += rectArea(r[i]) - itsArea(i);
		} else area=rectArea(r[0]);

	}

	cout << area << "\n";
}
