#include <cstdio>

#define MAXN 15000

int K, N, ans;
int X[MAXN], H[MAXN];
int dyn[MAXN];//dyn[i] contains the least guarded towers before tower[i] if we retain the guards at tower[i]

//returns if the tower with distance xl and height difference yl is not hidden by the tower with xo and yo
bool IsVisible(int xl, int yl, int xo, int yo)
{
    return((double)yl/(double)xl > (double)yo/(double)xo);
}

int main()
{
    scanf("%d %d", &N, &K);

    for(int i = 0;i < N;i++)
        scanf("%d %d", &X[i], &H[i]);

    dyn[0] = 1;

    for(int i = 1;i < N;i++)
    {
        int mins = N;
        for(int j = i-1;j >= 0;j--)
        {
            if(X[i] - X[j] > K)//check distance
                break;

            bool vis = true;
            for(int q = j+1;q < i;q++)//check visibility
                if(!IsVisible(X[i]- X[j], H[i] - H[j], X[q] - X[j], H[q] - H[j]))
                {
                    vis = false;
                    break;
                }

            if(vis)//check if that leads to better solution
                if(mins > dyn[j])
                    mins = dyn[j];
        }

        dyn[i] = mins + 1;
    }

    printf("%d\n", dyn[N-1]);

    return 0;
}
