/*
TASK: towers
LANG: C++
*/

#include <cstdio>
#include <cstring>
#include <utility>

using namespace std;

const int MAXN = 15005;
const int MAXK = 205;

typedef pair < int, int > Pii;

int node[MAXN], en;
struct el {
	int to, next;
	el () {}
	el ( int _to, int _next ) : to(_to), next(_next) {}
} l[ MAXN * MAXK ];

inline void add_edge ( int v, int u ) {
	l[en] = el ( u, node[v] );
	node[v] = en ++;
}

int N, K, ans[MAXN];
Pii a[MAXN];

int main (void) {
	
	en = 0;
	memset ( node, -1, sizeof node );
	memset ( ans, 23, sizeof ans );
	
	scanf ( "%d%d", &N, &K );
	for ( int i=1; i<=N; ++i ) scanf ( "%d%d", &a[i].first, &a[i].second );
	
	for ( int i=1; i<N; ++i ) {
		
		double min_sin = -1e17, A, B, C, t_sin;
		for ( int j=i+1; j <= N && a[j].first - a[i].first <= K; ++j ) {
			
			A = a[j].first - a[i].first;
			B = a[j].second - a[i].second;
			C = A * A + B * B;
			t_sin = ( B * B / C ) * ( B < 0. ? -1. : 1. );
			if ( min_sin < t_sin ) {
				min_sin = t_sin;
				add_edge ( i, j );
				}
			
			}
		
		}
	
	ans[1] = 1;
	for ( int i=1; i<N; ++i )
		for ( int j=node[i]; j!=-1; j=l[j].next )
			if ( ans[ l[j].to ] > ans[i] + 1 ) ans[ l[j].to ] = ans[i] + 1;
	
	printf ( "%d\n", ans[N] );
	
}
